%if 0%{?fedora} || 0%{?rhel} >= 8
%global with_py3 1
%endif

%global pkgname BTrees

Name:           python-%{pkgname}
Version:        4.1.4
Release:        2%{?dist}
Summary:        Scalable persistent object containers

License:        ZPLv2.1
URL:            http://www.zodb.org/
Source0:        https://pypi.python.org/packages/source/B/%{pkgname}/%{pkgname}-%{version}.tar.gz

BuildRequires:  python-devel
BuildRequires:  python-nose
BuildRequires:  python-persistent-devel
BuildRequires:  python-repoze-sphinx-autointerface
BuildRequires:  python-setuptools
BuildRequires:  python-sphinx
BuildRequires:  python-transaction
BuildRequires:  python-zope-interface

%if 0%{?with_py3}
BuildRequires:  python3-devel
BuildRequires:  python3-nose
BuildRequires:  python3-persistent-devel
BuildRequires:  python3-repoze-sphinx-autointerface
BuildRequires:  python3-setuptools
BuildRequires:  python3-sphinx
BuildRequires:  python3-transaction
BuildRequires:  python3-zope-interface
%endif

Requires:       python-persistent%{?_isa}
Requires:       python-zope-interface%{?_isa}

%global common_desc                                                      \
This package contains a set of persistent object containers built around \
a modified BTree data structure.  The trees are optimized for use inside \
ZODB's "optimistic concurrency" paradigm, and include explicit           \
resolution of conflicts detected by that mechanism.

%description
%{common_desc}

%if 0%{?with_py3}
%package -n python3-%{pkgname}
Summary:        Scalable persistent object containers
Requires:       python3-persistent%{?_isa}
Requires:       python3-zope-interface%{?_isa}

%description -n python3-%{pkgname}
%{common_desc}
%endif

%prep
%setup -q -c

# Remove prebuilt egg and documentation
rm -fr %{pkgname}-%{version}/%{pkgname}.egg-info \
  %{pkgname}-%{version}/docs/_build

%if 0%{?with_py3}
# Prepare for a python3 build
cp -a %{pkgname}-%{version} python3-%{pkgname}-%{version}
%endif

%build
# Python 2 build
pushd %{pkgname}-%{version}
CFLAGS="%{optflags} -IBTrees" %{__python2} setup.py build
PYTHONPATH=$(echo $PWD/build/lib.linux-*) make -C docs html
popd

%if 0%{?with_py3}
# Python 3 build
pushd python3-%{pkgname}-%{version}
CFLAGS="%{optflags} -IBTrees" %{__python3} setup.py build
PYTHONPATH=$(echo $PWD/build/lib.linux-*) make -C docs html \
  SPHINXBUILD=%{_bindir}/sphinx-build-3.*
popd
%endif

%install
# Python 2 install
pushd %{pkgname}-%{version}
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}
popd

%if 0%{?with_py3}
# Python 3 install
pushd python3-%{pkgname}-%{version}
%{__python3} setup.py install -O1 --skip-build --root %{buildroot}
popd
%endif

# Remove unwanted documentation and source files; fix permissions (Python 2)
rm -f %{pkgname}-%{version}/docs/_build/html/.buildinfo
rm -f %{buildroot}%{python2_sitearch}/%{pkgname}/*.{c,h}
chmod 0755 %{buildroot}%{python2_sitearch}/%{pkgname}/*.so

%if 0%{?with_py3}
# Remove unwanted documentation and source files; fix permissions (Python 3)
rm -f python3-%{pkgname}-%{version}/docs/_build/html/.buildinfo
rm -f %{buildroot}%{python3_sitearch}/%{pkgname}/*.{c,h}
chmod 0755 %{buildroot}%{python3_sitearch}/%{pkgname}/*.so
%endif

%check
# Python 2 tests
pushd %{pkgname}-%{version}
%{__python2} setup.py test
popd

%if 0%{?with_py3}
# Python 3 tests
pushd python3-%{pkgname}-%{version}
%{__python3} setup.py test
popd
%endif

%files
%license %{pkgname}-%{version}/COPYRIGHT.txt %{pkgname}-%{version}/LICENSE.txt
%{python2_sitearch}/%{pkgname}*

%if 0%{?with_py3}
%files -n python3-%{pkgname}
%license %{pkgname}-%{version}/COPYRIGHT.txt %{pkgname}-%{version}/LICENSE.txt
%{python3_sitearch}/%{pkgname}*
%endif

%changelog
* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.1.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Jun  8 2015 Jerry James <loganjerry@gmail.com> - 4.1.4-1
- New upstream version

* Sat May 23 2015 Jerry James <loganjerry@gmail.com> - 4.1.3-1
- New upstream version

* Tue Apr 14 2015 Jerry James <loganjerry@gmail.com> - 4.1.2-1
- New upstream version

* Mon Jan  5 2015 Jerry James <loganjerry@gmail.com> - 4.1.1-1
- New upstream version
- Drop upstreamed -overflow patch
- Use license macro

* Tue Aug 12 2014 Jerry James <loganjerry@gmail.com> - 4.0.8-2
- Add -overflow patch to fix test failures with 32-bit python 3.4

* Mon Jun  2 2014 Jerry James <loganjerry@gmail.com> - 4.0.8-1
- Initial RPM
